#include <iostream>
#include <fstream>
#include "checker16.h"
#include "util.h"

using std::cout;
using std::cerr;
using std::endl;
using std::ifstream;

int main( int argc, char* argv[] )
   {
   char grid[ 128 ];
   if ( argc != 2 )
      {
      cout << "syntax: checker <inputfile>" << endl;
      return -1;
      }  
   // open input file
   ifstream input( argv[ 1 ] );
   if ( ! input )
      {
      cerr << "Unable to open input file \"" << argv[ 1 ] << "\"." << endl;
      return -1;
      }
   // now load one line (grid) at a time from input file and search for a 16
   float totaltime = 0;
   int   puzzles = 0;
   int   gridcount = 0;
   while ( input.getline( grid, sizeof( grid ) ) )
      {
      gridcount++;
      cout << "Inspecting grid no. " << gridcount << " ... " << endl;
      float gridtime;
      int const puzz = CheckGrid( grid, &gridtime );
      puzzles += puzz;
      totaltime += gridtime;
      // print running time for this grid and average running time for all grids searched so far
      cout << "found " << puzz << " hitting sets (" << gridtime << " seconds, average = " << totaltime / gridcount << " sec/grid)" << endl;
      }
   cout << GetCPUTime() << " seconds (" << puzzles << " puzzles)" << endl;
   return 0;
   }
